Package com.ads.api.util

# Class KeyValueUtil

java.lang.Object
com.ads.api.util.BaseUtil
com.ads.api.util.KeyValueUtil

public class KeyValueUtil extends com.ads.api.util.BaseUtil
Contains the methods to perform operations like adding, updating, deleting and retrieving the key value pairs.
In order to implement these operations on key values, usage of collection classes is being employed. For the ObjectTypeId reference you can utilize the handy AMMObjectTypes class We kept the option open incase, if the user wants to use any other Object Type Id across the system which is not supported by AMM natively In which case, stick to a number more greater than 100, leaving 1 - 100 for AMM System Defined Types

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.ads.api.util.BaseUtil

  `com.ads.api.util.BaseUtil.TokenType`

- ## Field Summary

  ### Fields inherited from class com.ads.api.util.BaseUtil

  `AUTH_TOKEN, AUTH_TOKEN_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `RequestStatus`
  `addKeyValue(KeyValue keyvalue)`
  Inserts a single KeyValue pair object for the specified KeyValue object.
  `RequestStatus`
  `addKeyValue(KeyValue keyvalue, Node.NodeType objectType, int objectId)`
  Inserts a single key value pair object for the specified key value object, objectType(nodeType) and objectId.
  `RequestStatus`
  `addKeyValue(String key, String value, String objectTypeId, String objectId)`
  Deprecated.
  `String`
  `addKeyValue(String key, String value, String objectTypeId, String objectId, String outputFormat)`
  Deprecated.
  `RequestStatus`
  `addKeyValue(String key, String value, String objectTypeId, List<String> objectIds)`
  Deprecated.
  `RequestStatus`
  `addKeyValue(String key, String value, Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Deprecated.
  `String`
  `addKeyValueAs(String keyValuejson, APIConstants.OutputFormat outputFormat)`
  Inserts a single KeyValue pair object for the specified KeyValue object,objectTypeId and objectId are mandatory.OutputFormat can be either JSON or XML.
  `String`
  `addKeyValueAs(String keyValuejson, Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat)`
  Inserts a single KeyValue pair object for the specified KeyValue object,objectTypeId and objectId.OutputFormat can be either JSON or XML.
  `String`
  `addKeyValueAs(String key, String Value, String ObjectTypeIdsListOfObjectIdsJson, String outputFormat)`
  Deprecated.
  `RequestStatus`
  `addKeyValueMap(Map<String,String> hmKeyValue, String objectTypeId, String objectId)`
  Deprecated.
  `RequestStatus`
  `addKeyValueMap(Map<String,String> hmKeyValue, String objectTypeId, List<String> objectIds)`
  Deprecated.
  `RequestStatus`
  `addKeyValueMap(Map<String,String> hmKeyValue, Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Deprecated.
  `String`
  `addKeyValueMapAs(String keyValueMapJson, String ObjectTypeIdsListOfObjectIdsJson, String outputFormat)`
  Deprecated.
  Sample 'keyValueMapJson' JSON :
  {
  "key1": "value1",
  "key2": "value2"
  }
  `String`
  `addKeyValueMapAs(String keyvalueMapJson, String objectTypeId, String objectIdListJson, String outputFormat)`
  Deprecated.
  Sample 'keyvalueMapJson' JSON :
  {
  "key1": "value1",
  "key2": "value2"
  }
  `RequestStatus`
  `addKeyValues(List<KeyValue> keyvalues, Node.NodeType objectType, int objectId)`
  Inserts a multiple key value pair objects for the specified list of key values given objectType(nodeType) and objectId.
  `RequestStatus`
  `addKeyValues(Map<Integer,List<KeyValue>> keyvalues, Node.NodeType objectType)`
  Inserts multiple key value pair objects for the specified node type and given objectIds along with key value objects.
  `String`
  `addKeyValuesAs(String keyValuejson, Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat)`
  Inserts a multiple KeyValue pair objects for the specified List of KeyValue objects,objectTypeId and objectId.OutputFormat can be either JSON or XML.
  `String`
  `addKeyValuesAs(String keyValuemapjson, Node.NodeType objectType, APIConstants.OutputFormat outputFormat)`
  Inserts multiple key value pair objects for the specified node type and given objectIds along with key value objects.
  `String`
  `addKeyValuesAs(String keyvalueMapJson, String objectTypeId, String objectId, String outputFormat)`
  Deprecated.
  Sample 'keyvalueMapJson' JSON :
  {
  "key1": "value1",
  "key2": "value2"
  }
  `String`
  `addKeyValuesAs(String key, String value, String objectTypeId, String objectIdListJson, String outputFormat)`
  Deprecated.
  Sample 'objectIdListJson' JSON :
  {
  "objectId": [1,2]
  }
  `String`
  `deleteKeyValueListAs(String objectTypeId, String listobjectIdsJson, String outputFormat)`
  Delete all Keys for the specified ObjectTypeId and List of ObjectId's as JSON.outputFormat can be either JSON or XML.
  `String`
  `deleteKeyValueListAs(String listkeysJson, String objectTypeId, String objectId, String outputFormat)`
  Deletes all Keys for the specified List of keys, ObjectId and ObjectTypeId.outputFormat can be either JSON or XML.
  `String`
  `deleteKeyValueMapAs(String mapOfObjectTypeIdsWithListOfObjectIdsJson, String outputFormat)`
  Deletes all Keys for the specified Map of ObjectTypeId and List of ObjectId's.
  `RequestStatus`
  `deleteKeyValues(String objectTypeId, String objectId)`
  Deletes all Keys for the specified ObjectId and ObjectTypeId.
  `RequestStatus`
  `deleteKeyValues(String key, String objectTypeId, String objectId)`
  Deletes all Keys for the specified Key, ObjectId and ObjectTypeId.
  `RequestStatus`
  `deleteKeyValues(String objectTypeId, List<String> objectId)`
  Delete all Keys for the specified ObjectTypeId and List of ObjectId's.
  `RequestStatus`
  `deleteKeyValues(List<String> keyIds)`
  Deletes all Keys for the specified List of keyId's.
  `RequestStatus`
  `deleteKeyValues(List<String> keys, String objectTypeId, String objectId)`
  Deletes all Keys for the specified List of keys, ObjectId and ObjectTypeId.
  `RequestStatus`
  `deleteKeyValues(Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Deletes all Keys for the specified Map of ObjectTypeId with its List of ObjectId's.
  `String`
  `deleteKeyValuesAs(String keyIdsMapJson, String outputFormat)`
  Deletes all Keys for the specified List of keyId's.outputFormat can be either JSON or XML.
  `String`
  `deleteKeyValuesAs(String objectTypeId, String objectId, String outputFormat)`
  Deletes all Keys for the specified ObjectId and ObjectTypeId.outputFormat can be either JSON or XML.
  `String`
  `deleteKeyValuesAs(String key, String objectTypeId, String objectId, String outputFormat)`
  Deletes all Keys for the specified Key, ObjectId and Object Type Id.outputFormat can be either JSON or XML.
  `String`
  `getKeyIdListAs(String keys, String objectTypeId, String objectId, String outputFormat)`
  Returns the keyId's String in the specified outputFomrat for the specified List of keys, objectTypeId and objectId.
  `Map<String,List<String>>`
  `getKeyIds(String objectTypeId, String objectId)`
  Returns the Map of keyId's for the specified objectTypeId and objectId.
  `List<String>`
  `getKeyIds(String key, String objectTypeId, String objectId)`
  Returns the List of keyIds for the specified key, objectTypeId and objectId.
  `Map<String,List<String>>`
  `getKeyIds(String key, String objectTypeId, List<String> objectId)`
  Returns the Map of keyIds for the specified key, objectTypeId and List of objectId's.
  `Map<String,List<String>>`
  `getKeyIds(List<String> keys, String objectTypeId, String objectId)`
  Returns the Map of keyId's for the specified List of keys, objectTypeId and objectId.
  `Map<String,Map<String,Map<String,List<String>>>>`
  `getKeyIds(Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Returns the Map of keyId's for the specified Map of objectTypeIds with its list of objectIds.
  `String`
  `getKeyIdsAs(String ObjectTypeIdListObjectId, String outputFormat)`
  Returns the keyId's String in the specified outputFormat for the specified Map of objectTypeId and List of objectIds.
  `String`
  `getKeyIdsAs(String objectTypeId, String objectId, String outputFormat)`
  Returns the keyId's as String in the specified outputFormat for the specified objectTypeId and objectId.
  `String`
  `getKeyIdsAs(String key, String objectTypeId, String objectId, String outputFormat)`
  Returns the List of keyId's for the specified key, objectTypeId and objectId in the specified outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getKeyIdsByObjectIds(String key, String objectTypeId, String listobjectIdJson, String outputFormat)`
  Returns the Map of keyId's for the specified key, objectTypeId and List of objectId's.
  `String`
  `getKeyValueAs(Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat)`
  Returns the List of KeyValue Objects for the specified objectTypeId and objectId.
  `KeyValue`
  `getKeyValueById(int keyId)`
  Returns the KeyValue object for the specified keyId
  `String`
  `getKeyValueMapAs(String ObjectTypeIdMapWithObjectIdsListJson, String outputFormat)`
  Returns Map of Key Value pairs for the specified List of objectTypeId's and objectId's in JSON in the specified outputFormat.
  `Map<Integer,List<KeyValue>>`
  `getKeyValues(Node.NodeType objectType, List<Integer> objectIds)`
  Returns the Map of KeyValue Objects for the specified objectType and list of objectIds.
  `Map<String,String>`
  `getKeyValues(String objectTypeId, String objectId)`
  Returns Map of KeyValue pairs for the specified objectTypeId and objectId.
  `String`
  `getKeyValues(String objectTypeId, String objectId, String outputFormat)`
  Returns Key Value pairs as String in the specified outputFormat for the specified objectTypeId and objectId.
  `Map<String,String>`
  `getKeyValues(String objectTypeId, String objectId, List<String> keyNames)`
  Returns Map with Key and Values for the ObjectTypeId and ObjectId filtering on KeyNames For Undefined / Unknown values the key will be preserved with a null value
  `Map<String,String>`
  `getKeyValues(String objectTypeId, String objectId, List<String> keyNames, boolean skipUnknown)`
  Returns Map with Key and Values for the ObjectTypeId and ObjectId filtering on KeyNames *
  `Map<String,Map<String,Map<String,String>>>`
  `getKeyValues(Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Returns Map of KeyValue pairs for the specified Map of objectTypeId's with List of objectId's.
  `String`
  `getKeyValuesAs(Node.NodeType objectType, List<Integer> objectIds, APIConstants.OutputFormat outputFormat)`
  Returns the Map of KeyValue Objects for the specified objectTypeId and List of objectIds.
  `String`
  `getKeyValuesAs(String ObjectTypeIdsMapWithObjectIdsListJson, String outputFormat)`
  Returns Map of Key Value pairs for the specified String of objectTypeId's and List of objectId's as JSON in the specified outputFormat.
  `org.json.JSONArray`
  `getKeyValuesAsJSON(String objectTypeId, String objectId)`
  Returns the key value pairs for the specified objectTypeId and objectId.
  `org.json.JSONArray`
  `getKeyValuesAsJSON(Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Returns Map of KeyValue pairs for the specified Map of objectTypeId's with List of objectId's.
  `List<KeyValue>`
  `getKeyValuesList(Node.NodeType objectType, int objectId)`
  Returns the List of KeyValue Objects for the specified objectType and objectId.
  `RequestStatus`
  `updateKeyValue(KeyValue keyvalue)`
  Updates the Key Value pair Object for the specified KeyValue object, Specifying objectTypeId and objectId and KeyValueId are mandatory.
  `String`
  `updateKeyValue(String keyIdValue, String ObjectTypeIdListObjectId, String outputFormat)`
  Updates the Map of Key Value pairs for the specified Map of KeyIdValue, Map of objectTypeId's and List of objectId's.
  `RequestStatus`
  `updateKeyValue(String keyId, String value, String objectTypeId, String objectId)`
  Updates the single KeyValue pair for the specified keyId, value, objectTypeId and objectId.
  `String`
  `updateKeyValue(String keyId, String value, String objectTypeId, String objectId, String outputFormat)`
  Updates the single Key Value pair for the specified keyId, value, objectTypeId and objectId.
  `RequestStatus`
  `updateKeyValue(String keyId, String value, String objectTypeId, List<String> objectId)`
  Updates the single keyValue pair for the specified keyId, value, objectTypeId and list of objectId's.
  `RequestStatus`
  `updateKeyValue(String keyId, String value, Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Updates the same single key Value pair for the specified keyId, value, Map of objectTypeId's and List of objectId's.
  `RequestStatus`
  `updateKeyValue(Map<String,String> hmKeyIdValue, String objectTypeId, String objectId)`
  Updates the Map of KeyValue pairs for the specified Map of KeyIdValue, objectTypeId and objectId.
  `RequestStatus`
  `updateKeyValue(Map<String,String> hmKeyIdValue, String objectTypeId, List<String> objectId)`
  Updates the Map of Key Value pairs for the specified Map of KeyIdValue, objectTypeId and List of objectId's.
  `RequestStatus`
  `updateKeyValue(Map<String,String> hmKeyIdValue, Map<String,List<String>> mapObjectTypeIdListObjectId)`
  Updates the Map of KeyValue pairs for the specified Map of KeyIdValue, Map of objectTypeId's and List of objectId's.
  `String`
  `updateKeyValueAs(String keyValuejson, APIConstants.OutputFormat outputFormat)`
  Updates the Key Value pair Object for the specified KeyValue object, Specifying KeyValueId is mandatory.
  `String`
  `updateKeyValueAs(String keyIdValueMapJson, String objectTypeId, String objectId, String outputFormat)`
  Updates the Map of Key Value pairs for the specified Map KeyIdValue, objectTypeId and objectId.
  `String`
  `updateKeyValueAs(String keyId, String value, String objectTypeId, String listobjectIdsJson, String outputFormat)`
  Updates the single key value pair for the specified keyId, value, objectTypeId and List of objectId's.
  `RequestStatus`
  `updateKeyValues(List<KeyValue> keyvalues)`
  Updates the List of Key Value pair Objects for the specified List of KeyValue objects, Specifying objectTypeId and objectId and KeyValueId are mandatory.
  `String`
  `updateKeyValuesAs(String keyValuejson, APIConstants.OutputFormat outputFormat)`
  Updates the List of Key Value pair Objects for the specified List of KeyValue objects, Specifying KeyValueId is mandatory.
  `String`
  `updateKeyValuesAs(String keyIdValueMapJson, String objectTypeId, String objectIds, String outputFormat)`
  Updates the Map of Key Value pairs for the specified Map of KeyIdValue, objectTypeId and List of objectId'S.

  ### Methods inherited from class com.ads.api.util.BaseUtil

  `getAccessToken, getAccessTokenType, getTokenType, getUserDetails, permissionDeniedMessage, permissionDeniedStatus, setAccessToken, setAccessTokenType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### addKeyValue

    public RequestStatus addKeyValue(String key, String value, String objectTypeId, String objectId)
    Deprecated.
    Inserts a single key value pair for the specified objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    objectTypeId refers to the id given to a specific objectType such as SYSTEM, ENVIRONMENT, TABLE, COLUMN, COMPONENT, PROJECT, SUBJECT, MAPPING, MAPPING_ROW. objectId refers to the id of the type of the object specified.
    For Instance: 1) If objectTypeId of objectType SYSTEM is 1 then corresponding objectId will be the id of the particular system.
    2) If objectTypeId of objectType TABLE is 3 then corresponding objectId will be the id of the particular table.
    If Key Value pair is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `key` - String
      `value` - String
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValueMap

    public RequestStatus addKeyValueMap(Map<String,String> hmKeyValue, String objectTypeId, String objectId)
    Deprecated.
    Inserts a Map of Key Value pairs for the specified objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    If Key Value pairs are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `hmKeyValue` - Map Object
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValue

    public RequestStatus addKeyValue(String key, String value, String objectTypeId, List<String> objectIds)
    Deprecated.
    Inserts a single Key Value pair for the specified objectTypeId and List of objectId's. Specifying ObjectTypeId, ObjectId are mandatory.
    List of objectId's refers to the id's of all objects which are of same objectType(same objectTypeId).
    If Key Value pair is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `key` - String
      `value` - String
      `objectTypeId` - String
      `objectIds` - List
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValueMap

    public RequestStatus addKeyValueMap(Map<String,String> hmKeyValue, String objectTypeId, List<String> objectIds)
    Deprecated.
    Inserts a Map of Key Value pairs for the specified objectTypeId and List of objectId's. Specifying ObjectTypeId , ObjectId are mandatory.
    List of objectId's refers to the id's of all objects which are of same objectType(same objectTypeId).
    Adds the same Key Value pairs to all objects with the same objectTypeId.
    If Key Value pairs are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `hmKeyValue` - Map Object
      `objectTypeId` - String
      `objectIds` - List
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValueMap

    public RequestStatus addKeyValueMap(Map<String,String> hmKeyValue, Map<String,List<String>> mapObjectTypeIdListObjectId)
    Deprecated.
    Inserts a Map of KeyValue pairs for the specified Map of objectTypeId's and List of objectId's. Specifying ObjectTypeId, ObjectId are mandatory.
    Adds the same Key Value pairs to all objectId's with the same objectTypeId.
    Map of objectTypeId's has collection of multiple objectType's. Where each of the objectTypeId consists of the List of objectId's.
    If Key Value pairs are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `hmKeyValue` - Map Object
      `mapObjectTypeIdListObjectId` - List
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValue

    public RequestStatus addKeyValue(String key, String value, Map<String,List<String>> mapObjectTypeIdListObjectId)
    Deprecated.
    Inserts a single keyValue pair for the specified Map of objectTypeId's with List of objectId's. Specifying ObjectTypeId, ObjectId are mandatory.
    Map of objectTypeId's has collection of multiple objectType's. Where each of the objecTypeId consists of the List of objectId's.
    If Key Value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `key` - String
      `value` - String
      `mapObjectTypeIdListObjectId` - Map
    Returns:
      RequestStatus object
    Since:
      6.2

  - ### addKeyValue

    public RequestStatus addKeyValue(KeyValue keyvalue)
    Inserts a single KeyValue pair object for the specified KeyValue object. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If Key Value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `keyvalue` - KeyValue Object
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.2

  - ### addKeyValue

    public RequestStatus addKeyValue(KeyValue keyvalue, Node.NodeType objectType, int objectId)
    Inserts a single key value pair object for the specified key value object, objectType(nodeType) and objectId.
    If Key Value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `keyvalue` - KeyValue Object
      `objectType` - Node.NodeType
      `objectId` - int
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.2

  - ### addKeyValues

    public RequestStatus addKeyValues(List<KeyValue> keyvalues, Node.NodeType objectType, int objectId)
    Inserts a multiple key value pair objects for the specified list of key values given objectType(nodeType) and objectId. and objectId..
    If Key Value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `keyvalues` - List
      `objectType` - Node.NodeType
      `objectId` - int
    Returns:
      String - If List of KeyValue pair objects added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.2

  - ### addKeyValues

    public RequestStatus addKeyValues(Map<Integer,List<KeyValue>> keyvalues, Node.NodeType objectType)
    Inserts multiple key value pair objects for the specified node type and given objectIds along with key value objects. If key value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `keyvalues` - Map
      `objectType` - Node.NodeType
    Returns:
      RequestStatus object
    Since:
      14.0

  - ### getKeyValues

    public Map<String,String> getKeyValues(String objectTypeId, String objectId) throws Exception
    Returns Map of KeyValue pairs for the specified objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
    Returns:
      Map of Key Value pairs
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyValues

    public Map<String,Map<String,Map<String,String>>> getKeyValues(Map<String,List<String>> mapObjectTypeIdListObjectId) throws Exception
    Returns Map of KeyValue pairs for the specified Map of objectTypeId's with List of objectId's.
    Parameters:
      `mapObjectTypeIdListObjectId` - Map object
    Returns:
      Map object
    Throws:
      `Exception` -
      Example :

      Object | ObjectTypeId | Key | Value
      --- | --- | --- | ---
      Employee | T | K1 | V1
      Customer | T | K1 | V2
      Employee_Id | C | K1 | V3
      Customer_Id | C | K2 | V4

      Return

      T => {
      Employee | {K1: V1}
      Customer | {K1: V2}
      C => {
      Employee_Id | {K1: V3}
      Customer_Id | {K2: V4}
      }
      }

      Ex: Employee Table - Object

      KEY | VALUE
      --- | ---
      Map - Key | Object Type Id
      Map - Key | Object Id
      Map - Key Id | Key Value

    Since:
      6.2

  - ### getKeyValuesAsJSON

    public org.json.JSONArray getKeyValuesAsJSON(Map<String,List<String>> mapObjectTypeIdListObjectId) throws Exception
    Returns Map of KeyValue pairs for the specified Map of objectTypeId's with List of objectId's.
    Parameters:
      `mapObjectTypeIdListObjectId` - Map Object
    Returns:
      JSONArray - key value pairs
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyValuesAsJSON

    public org.json.JSONArray getKeyValuesAsJSON(String objectTypeId, String objectId) throws Exception
    Returns the key value pairs for the specified objectTypeId and objectId. Specifying ObjectTypeId , ObjectId are mandatory.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
    Returns:
      JSONArray - [{"KEY_NAME":"add","KEY_VALUE":"me","KEY_ID":"63"}]
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyIds

    public List<String> getKeyIds(String key, String objectTypeId, String objectId) throws Exception
    Returns the List of keyIds for the specified key, objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `objectId` - String
    Returns:
      List - KeyId's
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyIds

    public Map<String,List<String>> getKeyIds(String key, String objectTypeId, List<String> objectId) throws Exception
    Returns the Map of keyIds for the specified key, objectTypeId and List of objectId's. Specifying ObjectTypeId, ObjectId are mandatory.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `objectId` - List
    Returns:
      Map of KeyNames and its List of KeyId's.
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyIds

    public Map<String,List<String>> getKeyIds(String objectTypeId, String objectId) throws Exception
    Returns the Map of keyId's for the specified objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
    Returns:
      Map of KeyNames and its List of KeyId's.
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyIds

    public Map<String,List<String>> getKeyIds(List<String> keys, String objectTypeId, String objectId) throws Exception
    Returns the Map of keyId's for the specified List of keys, objectTypeId and objectId. Specifying ObjectTypeId, ObjectId are mandatory.
    Parameters:
      `keys` - List
      `objectTypeId` - String
      `objectId` - String
    Returns:
      Map of KeyNames and its List of KeyId's.
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyIds

    public Map<String,Map<String,Map<String,List<String>>>> getKeyIds(Map<String,List<String>> mapObjectTypeIdListObjectId) throws Exception
    Returns the Map of keyId's for the specified Map of objectTypeIds with its list of objectIds. Specifying ObjectTypeId , ObjectId are mandatory.
    Parameters:
      `mapObjectTypeIdListObjectId` - Map
    Returns:
      Map of KeyId's
    Throws:
      `Exception`
    Since:
      6.2

  - ### getKeyValuesList

    public List<KeyValue> getKeyValuesList(Node.NodeType objectType, int objectId) throws Exception
    Returns the List of KeyValue Objects for the specified objectType and objectId.
    Parameters:
      `objectType` - Node.NodeType
      `objectId` - int
    Returns:
      List of Key Value pairs
    Throws:
      `Exception`
    Since:
      8.2

  - ### getKeyValues

    public Map<Integer,List<KeyValue>> getKeyValues(Node.NodeType objectType, List<Integer> objectIds) throws Exception
    Returns the Map of KeyValue Objects for the specified objectType and list of objectIds.
    Parameters:
      `objectType` - Node.NodeType
      `objectIds` - List
    Returns:
      List of Key Value pairs
    Throws:
      `Exception`
    Since:
      8.2

  - ### getKeyValueById

    public KeyValue getKeyValueById(int keyId)
    Returns the KeyValue object for the specified keyId
    Parameters:
      `keyId` - int
    Returns:
      KeyValue Object
    Since:
      8.3

  - ### updateKeyValue

    public RequestStatus updateKeyValue(String keyId, String value, String objectTypeId, String objectId) throws Exception
    Updates the single KeyValue pair for the specified keyId, value, objectTypeId and objectId. Specifying Id, objectTYpeId and objectId are mandatory.
    Parameters:
      `keyId` - String
      `value` - String
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(String keyId, String value, String objectTypeId, List<String> objectId) throws Exception
    Updates the single keyValue pair for the specified keyId, value, objectTypeId and list of objectId's. Specifying Id, objectTYpeId and objectId are mandatory.
    Updates the same KeyValue pair for all objects with the same objectTypeId.
    Parameters:
      `keyId` - String
      `value` - String
      `objectTypeId` - String
      `objectId` - List
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(String keyId, String value, Map<String,List<String>> mapObjectTypeIdListObjectId) throws Exception
    Updates the same single key Value pair for the specified keyId, value, Map of objectTypeId's and List of objectId's. Specifying KeyIdValue, objectTYpeId and objectId are mandatory.
    Map of objectTypeId's consists of multiple objectTypes. Each of the objectType in turn consists of a List of objectId's
    Parameters:
      `keyId` - String
      `value` - String
      `mapObjectTypeIdListObjectId` - Map
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Throws:
      `Exception`
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(Map<String,String> hmKeyIdValue, String objectTypeId, String objectId)
    Updates the Map of KeyValue pairs for the specified Map of KeyIdValue, objectTypeId and objectId. Specifying KeyIdValue, objectTYpeId and objectId are mandatory.
    Updates the keyValue pairs available in the Map to the same objectTypeId and objectId.
    Parameters:
      `hmKeyIdValue` - Map Object
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(Map<String,String> hmKeyIdValue, String objectTypeId, List<String> objectId)
    Updates the Map of Key Value pairs for the specified Map of KeyIdValue, objectTypeId and List of objectId's. Specifying KeyIdValue, objectTYpeId and objectId are mandatory.
    Updates the key value pairs available in the Map to all objectId's of same objectTypeId.
    Parameters:
      `hmKeyIdValue` - Map
      `objectTypeId` - String
      `objectId` - List
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(Map<String,String> hmKeyIdValue, Map<String,List<String>> mapObjectTypeIdListObjectId)
    Updates the Map of KeyValue pairs for the specified Map of KeyIdValue, Map of objectTypeId's and List of objectId's. Specifying KeyIdValue, objectTYpeId and objectId are mandatory.
    Updates the Key Value pairs available to all objectsId's in the List of the Map of objectTypeId's.
    Parameters:
      `hmKeyIdValue` - Map Object
      `mapObjectTypeIdListObjectId` - Map Object
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### updateKeyValue

    public RequestStatus updateKeyValue(KeyValue keyvalue)
    Updates the Key Value pair Object for the specified KeyValue object, Specifying objectTypeId and objectId and KeyValueId are mandatory.
    Updates the Key Value pair for available KeyValueId.
    Parameters:
      `keyvalue` - KeyValue
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True,otherwise returns False.
    Since:
      8.2

  - ### updateKeyValues

    public RequestStatus updateKeyValues(List<KeyValue> keyvalues)
    Updates the List of Key Value pair Objects for the specified List of KeyValue objects, Specifying objectTypeId and objectId and KeyValueId are mandatory.
    Updates the Key Value available to objectsId and objectTypeId.
    Parameters:
      `keyvalues` - List Object
    Returns:
      RequestStatus Object - If the list of keyValue pair objects updated successfully, RequestStatus returns True,otherwise returns False.
    Since:
      8.2

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(String key, String objectTypeId, String objectId)
    Deletes all Keys for the specified Key, ObjectId and ObjectTypeId. Specifying keyName, objectTypeId and objectId are mandatory.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(List<String> keys, String objectTypeId, String objectId)
    Deletes all Keys for the specified List of keys, ObjectId and ObjectTypeId. Specifying keyName, objectTypeId and objectId are mandatory.
    Parameters:
      `keys` - List
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(List<String> keyIds)
    Deletes all Keys for the specified List of keyId's. Specifying Id's is mandatory.
    Parameters:
      `keyIds` - List
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2 KeyIds are unique Id's given to the Key Value Pairs.

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(String objectTypeId, String objectId)
    Deletes all Keys for the specified ObjectId and ObjectTypeId. Specifying objectTypeId and objectId are mandatory.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(String objectTypeId, List<String> objectId)
    Delete all Keys for the specified ObjectTypeId and List of ObjectId's. Specifying objectTypeId and objectId are mandatory.
    Parameters:
      `objectTypeId` - String
      `objectId` - List
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValues

    public RequestStatus deleteKeyValues(Map<String,List<String>> mapObjectTypeIdListObjectId)
    Deletes all Keys for the specified Map of ObjectTypeId with its List of ObjectId's. Specifying objectTypeId and objectId are mandatory.
    Parameters:
      `mapObjectTypeIdListObjectId` - Map
    Returns:
      RequestStatus Object - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### addKeyValue

    public String addKeyValue(String key, String value, String objectTypeId, String objectId, String outputFormat)
    Deprecated.
    Inserts a single key value pair for the specified Key, Value, objectTypeId and objectId. Specifying ObjectTypeId , ObjectId are mandatory.
    objectTypeId refers to the id given to a specific objectType such as SYSTEM, ENVIRONMENT, TABLE, COLUMN, COMPONENT, PROJECT, SUBJECT, MAPPING, MAPPING_ROW. objectId refers to the id of the type of the object specified.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    For Instance: 1) If objectTypeId of objectType SYSTEM is 1 then corresponding objectId will be the id of the particular system.
    2) If objectTypeId of objectType TABLE is 3 then corresponding objectId will be the id of the particular table.
    Parameters:
      `key` - String
      `value` - String
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String
    Returns:
      String - If Key Value pair is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValuesAs

    public String addKeyValuesAs(String keyvalueMapJson, String objectTypeId, String objectId, String outputFormat)
    Deprecated.

    Sample 'keyvalueMapJson' JSON :
    {
    "key1": "value1",
    "key2": "value2"
    }

    Inserts a Map of Key Value pairs for the specified KeyValueMap in JSON, objectTypeId and objectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyvalueMapJson` - Map Object
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Key Value pair is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValuesAs

    public String addKeyValuesAs(String key, String value, String objectTypeId, String objectIdListJson, String outputFormat)
    Deprecated.

    Sample 'objectIdListJson' JSON :
    {
    "objectId": [1,2]
    }

    Inserts a single Key Value pair for the specified key, value, objectTypeId and List of objectId's.Specifying ObjectTypeId , ObjectId are mandatory.
    List of objectId's refers to the id's of all objects which are of same objectType(same objectTypeId). outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `key` - String
      `value` - String
      `objectTypeId` - String
      `objectIdListJson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Key Value pair is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValueMapAs

    public String addKeyValueMapAs(String keyvalueMapJson, String objectTypeId, String objectIdListJson, String outputFormat)
    Deprecated.

    Sample 'keyvalueMapJson' JSON :
    {
    "key1": "value1",
    "key2": "value2"
    }

    Sample 'objectIdListJson' JSON :
    {
    "objectId": [74,76]
    }

    Inserts a Map of Key Value pairs for the specified keyValueMap in JSON, objectTypeId and List of objectId's.Specifying ObjectType Id , Object Id are mandatory.
    List of objectId's refers to the id's of all objects which are of same objectType(same objectTypeId).
    Adds the same KeyValue pairs to all objects with the same objectTypeId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyvalueMapJson` - String
      `objectTypeId` - String
      `objectIdListJson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Key Value pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValueMapAs

    public String addKeyValueMapAs(String keyValueMapJson, String ObjectTypeIdsListOfObjectIdsJson, String outputFormat)
    Deprecated.

    Sample 'keyValueMapJson' JSON :
    {
    "key1": "value1",
    "key2": "value2"
    }

    Sample 'ObjectTypeIdsListOfObjectIdsJson' JSON :
    {
    9: [1,2],
    8:[3,4]
    }

    Inserts a Map of KeyValue pairs for the specified Map of keyValue in JSON, objectTypeId's and objectId's in JSON.
    Adds the same KeyValue pairs to all objectId's with the same objectTypeId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Map of objectTypeId's has collection of multiple objectType's. Where each of the objectTypeId consists of the List of objectId's.
    Parameters:
      `keyValueMapJson` - String
      `ObjectTypeIdsListOfObjectIdsJson` - mapObjectTypeIdListObjectId List
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValueAs

    public String addKeyValueAs(String key, String Value, String ObjectTypeIdsListOfObjectIdsJson, String outputFormat)
    Deprecated.

    Sample 'ObjectTypeIdsListOfObjectIdsJson' JSON :
    {
    9:[1,2],
    8:[3,4]
    }

    Inserts a single keyValue pair for the specified key, value, objectTypeId's and objectId's JSON and outputFormat can be JSON or XML.
    JSON of objectTypeId's has collection of multiple objectType's. Where each of the objecTypeId consists of the List of objectId's.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If Key Value pair is added successfully then RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `key` - String
      `Value` - String
      `ObjectTypeIdsListOfObjectIdsJson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addKeyValueAs

    public String addKeyValueAs(String keyValuejson, APIConstants.OutputFormat outputFormat)
    Inserts a single KeyValue pair object for the specified KeyValue object,objectTypeId and objectId are mandatory.OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyValuejson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'keyValuejson' for this:
      {
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "id": 0,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "value": "",
      "pref_type": "Consolidated",
      "key": "Key1",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      }

    Since:
      8.2

  - ### addKeyValueAs

    public String addKeyValueAs(String keyValuejson, Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat)
    Inserts a single KeyValue pair object for the specified KeyValue object,objectTypeId and objectId.OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyValuejson` - String
      `objectType` - Node.NodeType
      `objectId` - int
      `outputFormat` - APIConstants.OutputFormat - Valid values: JSON or XML
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'keyValuejson' for this:
      {
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "id": 0,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      }

    Since:
      8.2

  - ### addKeyValuesAs

    public String addKeyValuesAs(String keyValuejson, Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat)
    Inserts a multiple KeyValue pair objects for the specified List of KeyValue objects,objectTypeId and objectId.OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyValuejson` - String
      `objectType` - Node.NodeType
      `objectId` - int
      `outputFormat` - APIConstants.OutputFormat - Valid values: JSON or XML
    Returns:
      String - If KeyValue pair is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'keyValuejson' JSON :
      [
      {
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "id": 0,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      },
      {
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "id": 0,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      }
      ]

    Since:
      8.2

  - ### addKeyValuesAs

    public String addKeyValuesAs(String keyValuemapjson, Node.NodeType objectType, APIConstants.OutputFormat outputFormat)
    Inserts multiple key value pair objects for the specified node type and given objectIds along with key value objects. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the nodeType, objectIds and keyValuejsonlist are mandatory.
    Parameters:
      `keyValuemapjson` - String
      `objectType` - Node.NodeType
      `outputFormat` - APIConstants.OutputFormat
    Returns:
      String - If key-value pair is added successfully, it will return RequestStatus object consisting of Request success flag, status message and userObject etc..in the form of JSON or XML String.

  - ### getKeyIdsAs

    public String getKeyIdsAs(String key, String objectTypeId, String objectId, String outputFormat)
    Returns the List of keyId's for the specified key, objectTypeId and objectId in the specified outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of KeyId's in the form of JSON or XML String.
    Since:
      6.2

  - ### getKeyIdsByObjectIds

    public String getKeyIdsByObjectIds(String key, String objectTypeId, String listobjectIdJson, String outputFormat)
    Returns the Map of keyId's for the specified key, objectTypeId and List of objectId's. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `listobjectIdJson` - String - objectIds List
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Map of KeyNames and its List of KeyId's in the form of JSON OR XML String.

      Sample 'listobjectIdJson' JSON :
      {
      "objectId":[1,2]
      }

    Since:
      6.2

  - ### getKeyValues

    public String getKeyValues(String objectTypeId, String objectId, String outputFormat)
    Returns Key Value pairs as String in the specified outputFormat for the specified objectTypeId and objectId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Map of Key Value pairs in the form of JSON or XML String.
    Since:
      6.2

  - ### getKeyValuesAs

    public String getKeyValuesAs(String ObjectTypeIdsMapWithObjectIdsListJson, String outputFormat)
    Returns Map of Key Value pairs for the specified String of objectTypeId's and List of objectId's as JSON in the specified outputFormat.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ObjectTypeIdsMapWithObjectIdsListJson` - String - ObjectTypeIds,List of ObjectIds Map object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Key value pairs Map Object in the form of JSON String

      Sample 'ObjectTypeIdsMapWithObjectIdsListJson' JSON :
      {
      9:[1,2],
      8:[3,4]
      }

    Since:
      6.2

  - ### getKeyValueMapAs

    public String getKeyValueMapAs(String ObjectTypeIdMapWithObjectIdsListJson, String outputFormat)
    Returns Map of Key Value pairs for the specified List of objectTypeId's and objectId's in JSON in the specified outputFormat.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ObjectTypeIdMapWithObjectIdsListJson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - JSONArray of key value pairs or XML
    Since:
      6.2

  - ### getKeyIdsAs

    public String getKeyIdsAs(String objectTypeId, String objectId, String outputFormat)
    Returns the keyId's as String in the specified outputFormat for the specified objectTypeId and objectId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Map of KeyNames and its List of KeyId's in the form of JSON or XML String.
    Since:
      6.2

  - ### getKeyIdListAs

    public String getKeyIdListAs(String keys, String objectTypeId, String objectId, String outputFormat)
    Returns the keyId's String in the specified outputFomrat for the specified List of keys, objectTypeId and objectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keys` - String
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Map of KeyNames and its List of KeyId's in the form of JSON or XML String.

      Sample 'keys' JSON :
      {
      keys:[key1,key2]
      }

    Since:
      6.2

  - ### getKeyIdsAs

    public String getKeyIdsAs(String ObjectTypeIdListObjectId, String outputFormat)
    Returns the keyId's String in the specified outputFormat for the specified Map of objectTypeId and List of objectIds.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `ObjectTypeIdListObjectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Map of KeyId's in the form of JSON or XML String.

      Sample 'ObjectTypeIdListObjectId' JSON :
      {
      "8":[1,2]
      }

    Since:
      6.2

  - ### getKeyValueAs

    public String getKeyValueAs(Node.NodeType objectType, int objectId, APIConstants.OutputFormat outputFormat) throws Exception
    Returns the List of KeyValue Objects for the specified objectTypeId and objectId.
    Parameters:
      `objectType` - Node.NodeType
      `objectId` - int
      `outputFormat` - - APIConstants.OutputFormat - Valid values: JSON or XML
    Returns:
      List of Key Value pairs
    Throws:
      `Exception`
    Since:
      8.2

  - ### getKeyValuesAs

    public String getKeyValuesAs(Node.NodeType objectType, List<Integer> objectIds, APIConstants.OutputFormat outputFormat) throws Exception
    Returns the Map of KeyValue Objects for the specified objectTypeId and List of objectIds.
    Parameters:
      `objectType` - String
      `objectIds` - List
      `outputFormat` - - Valid values: JSON or XML
    Returns:
      List of Key Value pairs
    Throws:
      `Exception` -

      Sample 'objectIdsJson' JSON :
      [1,2]

    Since:
      8.2

  - ### updateKeyValue

    public String updateKeyValue(String keyId, String value, String objectTypeId, String objectId, String outputFormat)
    Updates the single Key Value pair for the specified keyId, value, objectTypeId and objectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyId` - String
      `value` - String
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pair is updated successfully, it returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### updateKeyValueAs

    public String updateKeyValueAs(String keyId, String value, String objectTypeId, String listobjectIdsJson, String outputFormat)
    Updates the single key value pair for the specified keyId, value, objectTypeId and List of objectId's.
    Updates the same Key Value pair for all objects with the same objectTypeId.
    Parameters:
      `keyId` - String
      `value` - String
      `objectTypeId` - String
      `listobjectIdsJson` - objectIds List
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pair is updated successfully, it returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.

      Sample 'listobjectIdsJson' JSON :
      {
      "objectId":[1,2]
      }

    Since:
      6.2

  - ### updateKeyValueAs

    public String updateKeyValueAs(String keyIdValueMapJson, String objectTypeId, String objectId, String outputFormat)
    Updates the Map of Key Value pairs for the specified Map KeyIdValue, objectTypeId and objectId.
    Updates the key value pairs available in the Map to the same objectTypeId and objectId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyIdValueMapJson` - String KeyId,Value Map Object
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pair is updated successfully, it returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.

      Sample 'keyIdValueMapJson' JSON :
      {
      "1": "value1",
      "2": "value2"
      }

    Since:
      6.2

  - ### updateKeyValuesAs

    public String updateKeyValuesAs(String keyIdValueMapJson, String objectTypeId, String objectIds, String outputFormat)
    Updates the Map of Key Value pairs for the specified Map of KeyIdValue, objectTypeId and List of objectId'S.
    Updates the key value pairs available in the Map to all objectId's of same objectTypeId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyIdValueMapJson` - String KeyId,Value Map Object
      `objectTypeId` - String
      `objectIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pairs are updated successfully, it returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.

      Sample 'keyIdValueMapJson' JSON :
      {
      "1": "value1",
      "2": "value2"
      }
      Sample 'objectIds' JSON :
      {
      "objectIds":[1,2]
      }

    Since:
      6.2

  - ### updateKeyValue

    public String updateKeyValue(String keyIdValue, String ObjectTypeIdListObjectId, String outputFormat)
    Updates the Map of Key Value pairs for the specified Map of KeyIdValue, Map of objectTypeId's and List of objectId's.
    Updates the Key Value pairs available to all objectsId's in the List of the Map of bjectTypeId's.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `keyIdValue` - Map Object
      `ObjectTypeIdListObjectId` - Map Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pair is updated successfully, it returns True along with the count of updated keyValues, from APIConstants.UPDATE_KEY_COUNT otherwise returns False.

      Sample 'keyIdValue' JSON :
      {
      1:"value1",
      2:"value2"
      }

      Sample 'ObjectTypeIdListObjectId' JSON :
      {
      8:[74,76]
      }

    Since:
      6.2

  - ### updateKeyValueAs

    public String updateKeyValueAs(String keyValuejson, APIConstants.OutputFormat outputFormat)
    Updates the Key Value pair Object for the specified KeyValue object, Specifying KeyValueId is mandatory.
    Updates the Key Value pair for available objectId and objectTypeId.
    Parameters:
      `keyValuejson` -
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      RequestStatus Object - If the keyValue pair is updated successfully, RequestStatus returns True,otherwise returns False.

      Sample 'keyValuejson' JSON :
      {
      "id": 0,
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      }

    Since:
      8.2

  - ### updateKeyValuesAs

    public String updateKeyValuesAs(String keyValuejson, APIConstants.OutputFormat outputFormat)
    Updates the List of Key Value pair Objects for the specified List of KeyValue objects, Specifying KeyValueId is mandatory.
    Updates the Key Value available to objectsId and objectTypeId.
    Parameters:
      `keyValuejson` - List Object
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      RequestStatus Object - If list of keyValue pair objects updated successfully, RequestStatus returns True,otherwise returns False.

      Sample 'keyValuejson' JSON :
      [
      {
      "id": 0,
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      },
      {
      "id": 0,
      "key": "",
      "value": "",
      "fromParent": false,
      "objectTypeId": "",
      "userData": {},
      "objectStyle": null,
      "defaultValue": "",
      "tooltip": null,
      "masterConfig": null,
      "fetchOnlyParent": false,
      "type": null,
      "mode": null,
      "valueRefId": null,
      "formatRefValues": true,
      "parentObjectTypeId": "",
      "systemBased": false,
      "html": false,
      "text": "",
      "order": 1,
      "fieldLength": 0,
      "visibility": 1,
      "keyStyle": null,
      "displayPolicy": 1,
      "published": false,
      "childId": 0,
      "fromChild": false,
      "processingOrder": 0,
      "dependencies": [],
      "expand": false,
      "consolidated": false,
      "parentKey": "",
      "configObject": null,
      "htmlDisabled": false,
      "fieldType": null,
      "regularExpression": null,
      "objectLevel": 0,
      "description": null,
      "mandatory": false,
      "enabled": false,
      "loadonStartup": 0,
      "parentObjectId": "",
      "selectedValue": null,
      "pref_type": "Consolidated",
      "objectId": "",
      "valueStyle": null,
      "combovalues": [],
      "uitype": "TEXTBOX",
      "keyValues": [],
      "parentId": 0,
      "component": "{}",
      "cellType": null
      }
      ]

    Since:
      8.2

  - ### deleteKeyValuesAs

    public String deleteKeyValuesAs(String key, String objectTypeId, String objectId, String outputFormat)
    Deletes all Keys for the specified Key, ObjectId and Object Type Id.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `key` - String
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pairs are deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValueListAs

    public String deleteKeyValueListAs(String listkeysJson, String objectTypeId, String objectId, String outputFormat)
    Deletes all Keys for the specified List of keys, ObjectId and ObjectTypeId.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `listkeysJson` - keys List
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pairs are deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.

      Sample 'listkeysJson' JSON :
      {
      keys:[key1,key2]
      }

    Since:
      6.2

  - ### deleteKeyValuesAs

    public String deleteKeyValuesAs(String keyIdsMapJson, String outputFormat)
    Deletes all Keys for the specified List of keyId's.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    KeyIds are unique Id's given to the Key Value Pairs.
    Parameters:
      `keyIdsMapJson` - keyIds List
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pairs are deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.

      Sample 'keyIdsMapJson' JSON :
      {
      "keyIds":[1,2]
      }

    Since:
      6.2

  - ### deleteKeyValuesAs

    public String deleteKeyValuesAs(String objectTypeId, String objectId, String outputFormat)
    Deletes all Keys for the specified ObjectId and ObjectTypeId.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `objectTypeId` - String
      `objectId` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pairs are deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.
    Since:
      6.2

  - ### deleteKeyValueListAs

    public String deleteKeyValueListAs(String objectTypeId, String listobjectIdsJson, String outputFormat)
    Delete all Keys for the specified ObjectTypeId and List of ObjectId's as JSON.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `objectTypeId` - String
      `listobjectIdsJson` - objectIds List
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue pair is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.

      Sample 'listobjectIdsJson' JSON :
      {
      objectId:[1,2]
      }

    Since:
      6.2

  - ### deleteKeyValueMapAs

    public String deleteKeyValueMapAs(String mapOfObjectTypeIdsWithListOfObjectIdsJson, String outputFormat)
    Deletes all Keys for the specified Map of ObjectTypeId and List of ObjectId's. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mapOfObjectTypeIdsWithListOfObjectIdsJson` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If the keyValue map is deleted successfully, RequestStatus returns True along with the count of deleted keyValues, from APIConstants.DELETE_KEY_COUNT otherwise returns False.

      Sample 'mapOfObjectTypeIdsWithListOfObjectIdsJson' JSON :
      {
      9:[1,2],
      8:[3,4]
      }

    Since:
      6.2

  - ### getKeyValues

    public Map<String,String> getKeyValues(String objectTypeId, String objectId, List<String> keyNames, boolean skipUnknown) throws Exception
    Returns Map with Key and Values for the ObjectTypeId and ObjectId filtering on KeyNames *
    Parameters:
      `objectTypeId` -
      `objectId` -
      `keyNames` -
      `skipUnknown` - To skip the unknown values from getting appended into returned Map
    Returns:
    Throws:
      `Exception`

  - ### getKeyValues

    public Map<String,String> getKeyValues(String objectTypeId, String objectId, List<String> keyNames) throws Exception
    Returns Map with Key and Values for the ObjectTypeId and ObjectId filtering on KeyNames For Undefined / Unknown values the key will be preserved with a null value
    Parameters:
      `objectTypeId` -
      `objectId` -
      `keyNames` -
    Returns:
    Throws:
      `Exception`